import gtk
import common
import numarray as na
import time
import struct
import socket
import copy
import pickle
import pdb

def flip(arr):
    r, c = arr.shape
    inv1 = -na.arange(r)-1
    inv2 = -na.arange(c)-1
    res = na.take(arr, inv2, axis = 1)
    return na.take(res, inv1, axis = 0)

class sMessage:
    def __init__(self):
    	self.typ = 0
	self.length = 0
	self.data = ''
    

class IRCamSocket:
    def __init__(self):
        """ constructor, setting initial variables """
        self._sleepperiod = 0.4
	self.smessage = sMessage()
        self.host = common.host
        self.port = common.port
##        print "self.host = ", self.host
##        print "self.port = ", self.port

    def initSocket(self):
        self.sock = None
        self.host = common.host
        self.port = common.port        
        for res in socket.getaddrinfo(self.host, self.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def readFrame(self):
        self.smessage.length = common.rows * common.cols * 4
        common.dataArray = na.zeros((common.rows, common.cols), type = na.Float32)
        #read frame
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFrame = 0
        else:
            self.flagSockFrame = 1
            self.sock.settimeout(30)
            self.sock.send('RD')
            self.sock.send(struct.pack('L', self.smessage.length))
##            print "sent data"
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.dataArray = na.fromstring(data, na.Float32, (common.rows, common.cols))
            common.dataArray = common.dataArray*self.mask()
##          print "saved data to dataArray"

    def readFLFrame(self):
        self.smessage.length = common.rows * common.cols * 2
        common.firstFrame = na.zeros((common.rows, common.cols), type = na.Float32)
        common.lastFrame = na.zeros((common.rows, common.cols), type = na.Float32)
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            return -1
        else:
            self.sock.settimeout(30)
            self.sock.send('FL')
            onefileready = self.sock.recv(2)
            if onefileready == 0:
                return 0
            else :
                length = 0
                data = ''
                while length < self.smessage.length:
                    self.smessage.data = self.sock.recv(self.smessage.length-length)
                    length += len(self.smessage.data)
                    data += self.smessage.data
                common.firstFrame = data

                length = 0
                data = ''
                while length < self.smessage.length:
                    self.smessage.data = self.sock.recv(self.smessage.length-length)
                    length += len(self.smessage.data)
                    data += self.smessage.data
                common.lastFrame = data
            return 1
                                                                                            
            
                                        

##     def readPS(self):
##         self.smessage.length = (common.rows/2) * (1+common.cols/4) * 4
##         #read power spectrum
##         self.initSocket()
##         if self.sock == None:
##             print "socket ps failed to create"
##             self.flagSockPS = 0
##         else:
##             self.flagSockPS = 1
##             self.sock.settimeout(30)
##             self.sock.send('PS')
##             self.sock.send(struct.pack('L', self.smessage.length))
##             print "sent data"
##             length = 0
##             data = ''
##             while length < self.smessage.length:
##                 self.smessage.data = self.sock.recv(self.smessage.length-length)
##                 length += len(self.smessage.data)
##                 data += self.smessage.data
##             self.sock.close()
##             psArray = na.fromstring(data, na.Float32, (common.rows/2 , 1+common.cols/4))
##             r = common.rows
##             c = common.cols
##             common.psArray = na.resize(common.psArray, (common.rows/2, 1+common.cols/2))
##             #top left        
##             common.psArray[:r/4, :c/4] = flip(psArray[:r/4, :])[:,:c/4]
##             #bottom left
##             common.psArray[r/4:, :c/4] = flip(psArray[r/4:, :])[:,:c/4]
##             tmp2 = common.psArray[:, :c/4].copy()
##             common.psArray[0, :c/4] = tmp2[r/2-1, :c/4]
##             common.psArray[1:, :c/4] = tmp2[0:r/2-1, :c/4]
            
##             #top right
##             common.psArray[:r/4, c/4:] = psArray[r/4:, :]
##             #bottom right
##             common.psArray[r/4:, c/4:] = psArray[:r/4, :]
##             #set to zero the central columns
##             common.psArray[:, c/4-2:c/4+3] = 0
##             print "saved data to psArray"
        
    def mask(self):
        img = na.ones((256, 256))
        

## 	    self.img[0,0] = 0
## 	    self.img[0,127] = 0
## 	    self.img[0,255] = 0
## 	    self.img[0,128] = 0
## 	    self.img[1,127] = 0
## 	    self.img[1,128] = 0
##             self.img[1,255] = 0
## 	    self.img[1,0] = 0
##             self.img[2,245] = 0
## 	    self.img[2,115] = 0
##             self.img[8,116] = 0
 ## 	    self.img[27,88] = 0
## 	    self.img[31,139] = 0
##             self.img[32,140] = 0
##   	    self.img[32,139] = 0
##             self.img[39,120] = 0
##             self.img[79,106] = 0
##             self.img[80,148] = 0
##             self.img[80,149] = 0
##             self.img[82,22] = 0
##     	    self.img[84,149] = 0
##             self.img[128,127] = 0
## 	    self.img[128,128] = 0
## 	    self.img[128,0] = 0
## 	    self.img[128,255] = 0
## 	    self.img[129,0] = 0
## 	    self.img[129,255] = 0
## 	    self.img[129,128] = 0
##             self.img[129,127] = 0 
##             self.img[130,255] = 0
##             self.img[132,255] = 0
##             self.img[167,246] = 0
##             self.img[168,11] = 0
##             self.img[176,221] = 0
##             self.img[179,61] = 0
##             self.img[187,78] = 0
##             self.img[208,211] = 0
##             self.img[208,210] = 0
##             self.img[214,180] = 0
##             self.img[219,173] = 0
##             self.img[230,239] = 0
##             self.img[249,217] = 0
##             self.img[249,218] = 0
##             self.img[249,219] = 0
## array([6,12,23,83,89,127,127,127,127,127,127,127,181,255,255,255,255,255,255,255,255,255])
## array([ 11,164,79,232,24,0,1,2,3,128,129,130,210,0,1,2,12,127,128,129,130,132])
## 2 (array([  6,  82,  83,  89, 150, 181]),
##        array([127,  76, 232,  24,  77, 210]))
## 3 (array([  6,  23, 127, 127, 127, 127, 220, 255, 255, 255, 255, 255, 255]),
##        array([127,  79,   0,   1, 128, 130, 245,   0,   1,   2,   3, 127, 129]))
## 3 (array([ 89,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,220,255,255,255,\
##        255, 255, 255,255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255]),
##       array([ 24,   0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  11, 128,
##       129, 130, 131, 132, 134, 136, 245,   0,   1,   2,   3,   4,   5,
##         6,   9, 127, 128, 129, 130, 131, 132, 133, 134, 135]))
## 3 (array([  6,  11,  23,  82, 127, 127, 127, 127, 127, 127, 127, 127, 127,
##        127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
##        127, 127, 127, 127, 127, 127, 127, 127, 186, 255, 255, 255, 255,
##       255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
##        255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
##        255, 255, 255, 255]),
## array([127,  63,  79,  76,   0,   1,   2,   3,   4,   5,   6,   7,   8,
##          9,  10,  12,  13,  14,  35, 128, 129, 130, 131, 132, 133, 134,
##        135, 136, 137, 138, 139, 140, 146, 149, 212,   0,   1,   2,   3,
##          4,   5,   6,   7,   8,   9,  10,  11,  12,  15,  16,  18,  22,
##        127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138, 139,
##        141, 143, 144, 153]))
## 3 (array([  6,  12,  82,  89, 189, 190]), array([127, 164,  76,  24, 227, 227]))
## 2 (array([  6,  12,  82,  89, 127, 127, 127, 127, 127, 127, 127, 127, 127,
##        127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
##        127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
##        127, 127, 127, 127, 127, 127, 127, 127, 127, 189, 190, 222, 255,
##        255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
##        255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
##        255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
##        255, 255, 255, 255, 255, 255, 255, 255]),
##   array([127, 164,  76,  24,   0,   1,   2,   3,   4,   5,   6,   7,   8,
##          9,  12,  13,  14,  16,  17,  19,  20,  26,  27, 128, 129, 130,
##        131, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143,
##        145, 146, 147, 148, 151, 152, 156, 160, 161, 227, 227, 172,   0,
##          1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,
##         14,  15,  17,  18,  19,  24,  29, 127, 128, 129, 130, 131, 132,
##        133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145,
##        147, 150, 151, 155, 162, 169, 174, 176]))

##         i = [ 12,23,62,79,89,117,127,181,220,222,164,175,114,174,6,8,9,11,12,62,28,166,82,4,148,6]
##         j = [164,79,175,183,24,5,1,210,245,172,107,158,150,215,127,92,92,62,165,176,210,61,76,11,126,11]
        i =[  1,  26,  28,  41,  41,  54,  67,  67,  82,  87, 100, 104, 142,\
              143, 143, 147, 165, 175, 182, 183, 189, 193, 210, 233, 236]
        j = [ 62, 235, 186,  35, 167, 141,  33,  79,  99, 166, 211,  23, 163,\
              162, 163,  94, 118, 153, 205, 245, 193,  71,  73, 194, 238]
        #pdb.set_trace()
        img[i,j] = 0
        tmp = na.zeros((common.rows, common.cols))
        tmp[ 0:common.rows/2, 0:common.cols/2,] =\
                             img[128-common.rowOffset-common.rows/2:128-common.rowOffset,\
                                 common.colOffset:common.colOffset+common.cols/2]
        tmp[0:common.rows/2, common.cols/2:common.cols] =\
                             img[128-common.rowOffset-common.rows/2:128-common.rowOffset, \
                                 128+common.colOffset:128+common.colOffset+common.cols/2]
        tmp[common.rows/2:common.rows, 0:common.cols/2] =\
                             img[256-common.rowOffset-common.rows/2:256-common.rowOffset, \
                                common.colOffset:common.colOffset+common.cols/2]        
        tmp[common.rows/2:common.rows, common.cols/2:common.cols] =\
                             img[256-common.rowOffset-common.rows/2:256-common.rowOffset, \
                                 128+common.colOffset:128+common.colOffset+common.cols/2]
        return tmp
        
