import gtk
import socket
import numarray as  na
import gobject
import copy
import time
import fringeIconsTiny as fringeIcons
import common
import IRCamCommands
import pdb
from httplib import HTTP
import pickle
### usage
### write data
### fichier=open('file', 'w')
### pickle.dump(data, fichier)
### fichier.close()
### read data
### fichier=open('file', 'r')
### data = pickle.load(fichier)
### fichier.close()
import string, re, sys

def scale_set_default_values(scale):
    scale.set_update_policy(gtk.UPDATE_CONTINUOUS)
    scale.set_digits(1)
    scale.set_value_pos(gtk.POS_TOP)
    scale.set_draw_value(True)

def create_arrow_button(arrow_type, shadow_type):
    button = gtk.Button();
    arrow = gtk.Arrow(arrow_type, shadow_type);
    button.add(arrow)
    button.show()
    arrow.show()
    return button

def create_double_arrow_button(arrow_type, shadow_type):
    button = gtk.Button();
    hbox = gtk.HBox()
    arrow = gtk.Arrow(arrow_type, shadow_type);
    hbox.add(arrow)
    arrow = gtk.Arrow(arrow_type, shadow_type);
    hbox.add(arrow)
    button.add(hbox)
    button.show()
    arrow.show()
    return button

class serverParameters(gtk.Window):
    def __init__(self, parent=None):
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())
            
        self.set_title("server parameters")
        self.set_default_size(150, 200)
        
        table = gtk.Table(1, 3, False)
        self.add(table)

        self.host = common.host
        self.port = common.port

        frame = gtk.Frame("server IP")
        hostEntry = gtk.Entry()
        hostEntry.set_size_request(40, 20)
        hostEntry.set_text(self.host)
        hostEntry.connect("activate", self.serverSetEntry, 'host')
        frame.add(hostEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      0,1,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        frame = gtk.Frame("server port")
        hostEntry = gtk.Entry()
        hostEntry.set_size_request(40, 20)
        hostEntry.set_text(str(self.port))
        hostEntry.connect("activate", self.serverSetEntry, 'port')
        frame.add(hostEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      1,2,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        button = gtk.Button('close')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      2, 3,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        
        self.show_all()

    def serverSetEntry(self, widget, data):
        entry = widget.get_text()
        if data == 'host':
            self.host = entry
            common.host = self.host
            print "New IP is: ", self.host

        elif data == 'port':
            self.port = int(entry)
            common.port = self.port
            print "New port is: ", self.port
        
            
class delayLinesControl2(gtk.Window):
    def __init__(self, parent=None):
        self.ircc = IRCamCommands.IRCamCommands()
        self.telNames = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
        self.activeTel = [True, True, True, True, True, True]
        self.refTel = [True, False, False, False, False, False]
        self.beamOrder = self.queryTiptilt()
        if self.beamOrder == None:
            self.beamOrder = ['1', '2', '3', '4', '5', '6']
        self.beamInUse = []
        self.nDelayLines = 6
        self.nBaselines = self.nDelayLines*(self.nDelayLines-1)/2
        for i in range(self.nDelayLines):
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
        self.beamInUse.sort()
        self.beamOrderDict = {}
        for i in range(6):
            self.beamOrderDict[self.beamOrder[i]] = self.telNames[i]

        common.activeTel = self.activeTel
            
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title(self.__class__.__name__)
        self.set_default_size(400, 400)
        
        table = gtk.Table(10, 40, False)
        self.add(table)

                
        self.updateGdtTag = [-1]*self.nBaselines
        self.checkThreshold = [True]*self.nDelayLines
        self.threshold = na.array([100.]*self.nBaselines*2)
        self.steps = na.array([0.005]*self.nDelayLines)
        self.Relative = na.zeros(self.nDelayLines,  type=na.Float64)
        self.Absolute = na.zeros(self.nDelayLines,  type=na.Float64)
        self.posiEntry = []
        self.entrySteps = []
        self.weightEntry = []
        self.opdEntry = []
        self.thresholdEntry = []
        self.weightFrame = []
        self.opdFrame = []
        thresholdFrame = []
        self.beam = []
        self.baselineBeam = {1:2, 3:3, 6:4, 10:5, 15:6}
        #baselines are 1-2, 1-3, 1-4, 1-5, 1-6, 2-3, 2-4, 2-5, 2-6, 3-4, 3-5, 3-6, 4-5, 4-6, 5-6
        
        self.baselines = [self.telNames[0]+self.telNames[1], self.telNames[0]+self.telNames[2],
                    self.telNames[0]+self.telNames[3], self.telNames[0]+self.telNames[4],
                    self.telNames[0]+self.telNames[5], self.telNames[1]+self.telNames[2],
                    self.telNames[1]+self.telNames[3], self.telNames[1]+self.telNames[4],
                    self.telNames[1]+self.telNames[5], self.telNames[2]+self.telNames[3],
                    self.telNames[2]+self.telNames[4], self.telNames[2]+self.telNames[5],
                    self.telNames[3]+self.telNames[4], self.telNames[3]+self.telNames[5],
                    self.telNames[4]+self.telNames[5]]
        self.weightLabels = [self.baselines[0], self.baselines[1], self.baselines[2], self.baselines[3], self.baselines[4], 
                            self.baselines[0], self.baselines[5], self.baselines[6], self.baselines[7], self.baselines[8],
                            self.baselines[1], self.baselines[5], self.baselines[9], self.baselines[10], self.baselines[11],
                            self.baselines[2], self.baselines[6], self.baselines[9], self.baselines[12], self.baselines[13],
                            self.baselines[3], self.baselines[7], self.baselines[10], self.baselines[12], self.baselines[14],
                            self.baselines[4], self.baselines[8], self.baselines[11], self.baselines[13], self.baselines[14]]
        self.weightPairs = [5, 10, 15, 20, 25,
                            0, 11, 16, 21, 26,
                            1, 6, 17, 22, 27,
                            2, 7, 12, 23, 28,
                            3, 8, 13, 18, 29,
                            4, 9, 14, 19, 24]
            
        for i in range(self.nDelayLines):
            self.posiEntry.append(gtk.Entry())
            self.entrySteps.append(gtk.Entry())
            txt = "DELAY LINE %s: beam " %(self.telNames[i])
            label = gtk.Label()
            label.set_markup('<b>%s</b>' %txt)
            label.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse("purple"))
            hbox = gtk.HBox(False,0)
            hbox.pack_start(label, False, False, 0)
            table.attach(hbox,
                        # X direction #          # Y direction
                        0, 8,                      i*4+1, i*4+2,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            self.beam.append(gtk.Entry())
            self.beam[i].set_text(self.beamOrder[i])
            self.beam[i].set_size_request(25, 25)
            self.beam[i].connect("activate", self.manualBeamSet, i)
            self.beam[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("purple"))
            #self.beam[i].set_editable(False)
            hbox.pack_start(self.beam[i], False, False, 0)

            button = gtk.CheckButton('use this tel')
            button.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse('red'))
            button.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse('red'))
            button.set_active(self.activeTel[i])
            button.connect("toggled", self.setActiveTel, i)
            button.set_size_request(80, 30)
            hbox.pack_start(button, False, False, 10)

            if i == 0:
                refTelButton = gtk.RadioButton(None, 'reference tel')
                refTelButton.set_active(self.refTel[i])
            else: refTelButton = gtk.RadioButton(refTelButton, 'reference tel')
            refTelButton.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse('red'))    
            refTelButton.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse('red'))    
            refTelButton.connect("toggled", self.setRefTel, i)
            refTelButton.set_size_request(100, 30)
            hbox.pack_start(refTelButton, False, False, 0)

            button = gtk.Button('ZERO')
            button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("skyblue"))
            button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("blue"))
            button.set_size_request(60, 20)
            button.connect("clicked", self.move_cb, "zero", i)
            table.attach(button,
                        # X direction #          # Y direction
                        0, 1,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);
            button = create_double_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(60, 30)
            button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("palegreen"))
            button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("green"))
            button.connect("clicked", self.move_cb, "fastLeft", i)
            table.attach(button,
                        # X direction #          # Y direction
                        1, 2,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            button = create_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(60, 30)
            button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("palegreen"))
            button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("green"))
            button.connect("clicked", self.move_cb, "left", i)
            table.attach(button,
                        # X direction #          # Y direction
                        2, 3,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            self.posiEntry[i].set_editable(False)
            self.posiEntry[i].set_text(str(self.Relative[i]))
            self.posiEntry[i].set_size_request(80, 30)
            table.attach(self.posiEntry[i],
                        # X direction #          # Y direction
                        3, 4,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            button = create_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(60, 30)
            button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("pink"))
            button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("red"))
            button.connect("clicked", self.move_cb, "right", i)
            table.attach(button,
                        # X direction #          # Y direction
                        4, 5,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            button = create_double_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(60, 30)
            button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("pink"))
            button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("red"))
            button.connect("clicked", self.move_cb, "fastRight", i)
            table.attach(button,
                        # X direction #          # Y direction
                        5, 6,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            
            frame = gtk.Frame("STEP SIZE")
            
            self.entrySteps[i].set_size_request(60, 20)
            self.entrySteps[i].set_text(str(self.steps[i]))
            self.entrySteps[i].connect("activate", self.enter_callback, i)
            frame.add(self.entrySteps[i])
            table.attach(frame,
                        # X direction #          # Y direction
                        0, 1,                      i*4+3, i*4+4,
                        0,     0,
                        0,                         0);
            button = gtk.ToggleButton('LOOP -')
            button.set_size_request(60, 30)
            button.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("green"))
            button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("green"))
            button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("palegreen"))
            button.connect('clicked', self.startLoop, 'minus', i)
            table.attach(button,
                        # X direction #          # Y direction
                        1, 2,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);
            
            button = gtk.ToggleButton('LOOP +')
            button.set_size_request(60, 30)
            button.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("red"))
            button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("red"))
            button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("pink"))
            button.connect('clicked', self.startLoop, 'plus', i)
            table.attach(button,
                        # X direction #          # Y direction
                        2, 3,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);
            
            button = gtk.CheckButton('threshold check')
            button.set_active(self.checkThreshold[i])
            button.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse('red'))    
            button.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse('red'))    
            button.connect("toggled", self.checkButton, i)
            button.set_size_request(120, 30)
            table.attach(button,
                        # X direction #          # Y direction
                        4, 6,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);

            sep = gtk.VSeparator()
            sep.set_size_request(20, 20)
            table.attach(sep,
                        # X direction #          # Y direction
                        6, 7,                      i*4+1, i*4+4,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
##             label = gtk.Label("OPD")
##             table.attach(label,
##                          # X direction #          # Y direction
##                          7, 8,                      i*4+1, i*4+2,
##                          gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
##                          0,                         0);
            label = gtk.Label("WEIGHT")
            table.attach(label,
                        # X direction #          # Y direction
                        7, 8,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            label = gtk.Label("THRESHOLD")
            table.attach(label,
                        # X direction #          # Y direction
                        7, 8,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);

            for j in range(self.nDelayLines-1):
                k = j+i*(self.nDelayLines-1)
                ndx = self.baselines.index(self.weightLabels[k])

                self.weightEntry.append(gtk.Entry())

                self.weightEntry[k].set_size_request(60, 20)
                self.weightFrame.append(gtk.Frame(self.weightLabels[k]))
                self.weightFrame[k].add(self.weightEntry[k])
                table.attach(self.weightFrame[k],
                            # X direction #          # Y direction
                            8+j, 9+j,                      i*4+2, i*4+3,
                            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                            0,                         0);
                self.thresholdEntry.append(gtk.Entry())
                self.thresholdEntry[k].set_size_request(60, 20)
                self.thresholdEntry[k].set_text(str(self.threshold[ndx]))
                self.thresholdEntry[k].connect("activate", self.enterThreshold,ndx, k)
                thresholdFrame.append(gtk.Frame())
                thresholdFrame[k].add(self.thresholdEntry[k])
                table.attach(thresholdFrame[k],
                            # X direction #          # Y direction
                            8+j, 9+j,                      i*4+3, i*4+4,
                            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                            0,                         0);
            sep = gtk.HSeparator()
            sep.set_size_request(60, 20)
            table.attach(sep,
                        # X direction #          # Y direction
                        0, 13,                      i*4+4, i*4+5,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
        
        button = gtk.Button('QUERY TIPTILT')
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', self.updateTiptilt)
        table.attach(button,
                    # X direction #          # Y direction
                    0, 2,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);

        button = gtk.Button('GET OFFSETS')
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', self.getOffsets)
        table.attach(button,
                    # X direction #          # Y direction
                    2, 4,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);

        frame  =gtk.Frame('SLEEP TIME')
        sleepEntry= gtk.Entry()
        sleepEntry.set_size_request(40, 20)
        frame.add(sleepEntry)
        sleepEntry.connect("activate", self.enterTime)
        sleepEntry.set_text('0.5')
        self.sleepTime = 1.0
        table.attach(frame,
                    # X direction #          # Y direction
                    4, 6,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);

        button = gtk.Button('CLOSE')
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            6, 8,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()

##         self.activeTel = [True, True, False, True, True, True]
## ##         w = [1, 2, 3, 4, 5, 6]
##         w = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
## ##         w = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15]
##         baselineBeam = {1:2, 3:3, 6:4, 10:5, 15:6}
##         ntels = baselineBeam[len(w)]
##         k = 0

##         beamInUse = []
##         for i in range(self.nDelayLines):
##             if self.activeTel[i] == True:
##                 beamInUse.append(self.beamOrder[i])
##         print "beamInUse = ", beamInUse
            
##         for i in range(ntels):
##             for j in range(i+1, ntels):
##                 wght = self.beamOrderDict[beamInUse[i]]+self.beamOrderDict[beamInUse[j]]
##                 loc = self.weightLabels.index(wght)
##                 print i+j, wght, loc
##                 self.weightEntry[loc].set_text("%10.3f" %(w[k]))
##                 self.weightEntry[self.weightPairs[loc]].set_text("%10.3f" %(w[k]))
##                 k+=1

        self.show_all()

    def move_cb(self, widget, status, ndx):
        print "status = ", status
        coeff = 10
        self.ircc.getDelayLinesOffsets()
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = 0.

        if (status == "fastLeft"):
                self.Relative[ndx] -= coeff*self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "left"):
                self.Relative[ndx] -= self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "zero"):
                self.Relative[ndx] = -self.Absolute[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "right"):
                self.Relative[ndx] += self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "fastRight"):
                self.Relative[ndx] += coeff*self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        self.ircc.getFringeInfo()
##         l = self.baselineBeam[len(common.weight)]-1
##         for i in range(l):
##             k = i+ndx*(self.nDelayLines-1)
##             self.weightEntry[k].set_text("%10.3f" %(common.weights[i]))
##             self.weightEntry[self.weightPairs[k]].set_text("%10.3f" %(common.weights[i]))

        ntels = baselineBeam[len(common.weight)]
        k = 0
        for i in range(ntels):
            for j in range(i+1, ntels):
                wght = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                loc = self.weightLabels.index(wght)
                print i+j, wght, loc
                self.weightEntry[loc].set_text("%10.3f" %(w[k]))
                self.weightEntry[self.weightPairs[loc]].set_text("%10.3f" %(common.weights[k]))
                k+=1

    def moveRelative(self):
        common.updatedOffsets = self.Relative.copy()*0.001
        self.Relative = 0.*self.Relative
        self.ircc.sendUpdatedOffsets()

    def sendToOple(self, widget):
        self.ircc.sendToOple()

    def getOffsets(self, widget):
        self.ircc.getDelayLinesOffsets()
        for ndx in range(self.nDelayLines):
            self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
            self.posiEntry[ndx].set_text("%10.3f" %(self.Absolute[ndx]))
        
    def checkButton(self, widget, ndx):
        self.checkThreshold[ndx] = widget.get_active()
        print self.checkThreshold
            
    def setActiveTel(self, widget, ndx):
        self.activeTel[ndx] = widget.get_active()
        common.activeTel = self.activeTel
        print self.activeTel
            
    def setRefTel(self, widget, ndx):
        self.refTel[ndx] = widget.get_active()
        print self.refTel
            
    def enterTime(self, widget):
        self.sleepTime = float(widget.get_text())
        print "New sleep time: ", self.sleepTime
        
    def enter_callback(self, widget, ndx):
        entry_text = self.entrySteps[ndx].get_text()
        self.steps[ndx] = float(entry_text)
        print "New step size: ", self.steps[ndx]

    def enterThreshold(self, widget, ndx, k):
        entry_text = widget.get_text()
        self.threshold[ndx] = float(entry_text)
        print "New threshold: ", self.threshold[ndx]
        self.thresholdEntry[self.weightPairs[k]].set_text(entry_text) 

        #SK: send all thresholds
        for n in range(15):
            common.autoThresh[n] = self.threshold[n]
        self.ircc.sendautoThresh()



    def startLoop(self, widget, sign, ndx):
        if widget.get_active():
            self.updateGdtTag[ndx] = gobject.idle_add(self.loopDelayLine, widget, sign, ndx)
        else:
            gobject.source_remove(self.updateGdtTag[ndx])

    def loopDelayLine(self, widget, sign, ndx):
        print "Calling loopDelayline with number ", ndx, "with sign ", sign
        flag = 0
        self.ircc.getDelayLinesOffsets()
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = 0.
        if sign == 'minus':
                self.Relative[ndx] -= self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif sign == 'plus':
                self.Relative[ndx] += self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        self.ircc.getFringeInfo()        
        ntels = baselineBeam[len(common.weight)]
        k = 0
        for i in range(ntels):
            for j in range(i+1, ntels):
                telcombo = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                loc = self.weightLabels.index(telcombo)
                print "loopDelayLine checking for fringes ", i+j, telcombo, loc
                self.weightEntry[loc].set_text("%10.3f" %(w[k]))
                self.weightEntry[self.weightPairs[loc]].set_text("%10.3f" %(common.weights[k]))
                if (common.weights[k] >= (self.threshold[loc]*self.thresholdfactor)):
                    flag = 1
                    self.weightEntry[loc].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
                    self.weightEntry[self.weightPairs[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
                else:
                    self.weightEntry[loc].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
                    self.weightEntry[self.weightPairs[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
                k+=1
                
        if (flag == 1) and (self.checkThreshold[ndx] == True):
            widget.set_active(False)
        else:
            time.sleep(self.sleepTime)
            return True
        
    def getFringeInfo(self, widget):
        self.ircc.getFringeInfo()
        for ndx in range(self.nBaselines):
            self.weightEntry[ndx].set_text("%i" %(int(common.weights[ndx])))     #10.3f
            self.opdEntry[ndx].set_text("%i" %(int(common.opds[ndx])))           #10.3f

    def initSocket(self):
        self.sock = None
        for port in range(6):
            for res in socket.getaddrinfo(self.host, self.port+port, socket.AF_UNSPEC, socket.SOCK_STREAM):
                af, socktype, proto, canonname, sa = res
                try:
                    self.sock = socket.socket(af, socktype, proto)
                except socket.error, msg:
                    self.sock = None
                    continue
                try:
                    self.sock.connect(sa)
                    self.fd = self.sock.fileno()
                except socket.error, msg:
                    self.sock.close()
                    self.sock = None
                    continue
                break
            if self.sock is None:
                print 'could not open socket on port: ', self.port+port
            else:
                break
            
    def queryTiptilt(self):
        self.host = '192.168.3.26'  #tiptilt
        self.port = 2000
        self.initSocket()
        beam = ['1', '2', '3', '4', '5', '6']
        if self.sock == None:
            print "socket frame failed to create"
            return None
        else:
            self.sock.settimeout(30)
            self.sock.send('status')
            length = 0
            l = 10
            data = ''
            while data.find('COMMAND_COMPLETE') == -1:
                message = self.sock.recv(100)
                l = len(message)
                length += l
                data += message
            self.sock.close()
            print data
            splitData = data.splitlines()
            tel = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
            for t in tel:
                for i in range(6):
                    if splitData[i+1].find(t) != -1:
                        beam[i] = str(i+1)
            print "beam = ", beam
            return beam
        
    def refreshTiptiltInfo(self):
        self.beamInUse = []
        for i in range(self.nDelayLines):
            self.beam[i].set_text(self.beamOrder[i])
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
        self.beamInUse.sort()

        
    def updateTiptilt(self,widget):
        self.beamOrder = self.queryTiptilt()
        if self.beamOrder == None:
            self.beamOrder = ['1', '2', '3', '4', '5', '6']
        self.refreshTiptiltInfo()
            
    def manualBeamSet(self, widget, i):
        self.beamOrder[i] = widget.get_text()
        self.refreshTiptiltInfo()
        

####################################################################

########################## GDT 2 ###################################
class gdtControl2(gtk.Window):
    def __init__(self, parent=None):
        self.sockTimeout = 20
        self.ircc = IRCamCommands.IRCamCommands()
        self.telNames = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
        self.activeTel = [True, True, True, True, True, True]
        self.refTel = [True, False, False, False, False, False]
        self.beamOrder = self.queryTiptilt()
        if self.beamOrder == None:
            self.beamOrder = ['1', '2', '3', '4', '5', '6']
        self.beamInUse = []
        self.nDelayLines = 6
        self.nBaselines = self.nDelayLines*(self.nDelayLines-1)/2
        for i in range(self.nDelayLines):
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
        self.beamInUse.sort()
        
        self.telColor = ['purple', 'blue', 'darkgreen', 'darkorange', 'red', 'magenta']
##         self.telColor = ['violet', 'skyblue', 'palegreen', 'orange', 'pink', 'darkred']
        self.colorDict = {}
        self.beamOrderDict = {}
        for i in range(6):
            self.beamOrderDict[self.beamOrder[i]] = self.telNames[i]
            self.colorDict[self.telNames[i]] = self.telColor[i]
        #print self.beamOrderDict, self.beamInUse

        common.activeTel = self.activeTel
            
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        screenWidth = gtk.gdk.screen_width()
        screenHeight = gtk.gdk.screen_height()
        
        #print "screenWidth = ", screenWidth, "screenHeight", screenHeight

        import os
        thmdir = gtk.rc_get_theme_dir()
        theme = os.path.join(thmdir, "Grand-Canyon", "gtk-2.0", "gtkrc")
        if os.path.exists(theme): style = "include '%s'\n" % theme
        else: style = ""

        # Here you can change any of the individual widget characteristics
        # as well as default fonts, colours etc.
        style = style + """
        style "mystyle"
        {
          font_name = "%s"
          GtkWidget::interior_focus = 1
        }
        widget "*" style "mystyle"

        style "mymenu"
        {
          font_name = "%s"
        }
        widget "*Menu*" style "mymenu"
        """ % ("Arial 8", "Arial 8")

        scale = 8

        # Apply this theme to your app
        gtk.rc_parse_string(style)
        self.set_title(self.__class__.__name__)
        self.set_default_size(400, 400)
        
        table = gtk.Table(10, 40, False)
        self.add(table)

        self.updateGdtTag = [-1]*self.nBaselines
        self.loopDLTag = -1
        self.checkThreshold = [True]*self.nDelayLines
        self.loopDLFlag = [False]*self.nDelayLines
        self.loopSign = ['plus']*self.nDelayLines
        self.threshold = na.array([20.]*self.nBaselines*2)
        self.thresholdfactor = 5
        self.steps = na.array([0.008]*self.nDelayLines)
        self.Relative = na.zeros(self.nDelayLines,  type=na.Float64)
        self.Absolute = na.zeros(self.nDelayLines,  type=na.Float64)
        self.posiEntry = []
        self.entrySteps = []
        self.weightEntry = []
        self.opdEntry = []
        self.thresholdEntry = []
        self.thresholdCalc = []
        self.baselineLabel1 = []
        self.baselineLabel2 = []
        self.weightFrame = []
        self.opdFrame = []
        thresholdFrame = []
        self.matrixFrame = []
        self.lockFringes = []
        self.beam = []
        self.baselineBeam = {1:2, 3:3, 6:4, 10:5, 15:6}
        
        self.fringeDetected = []
        self.loopMinusButton = []
        self.loopPlusButton = []
        
        self.matrixLock = []
        self.matrixSolve = []
        self.matrixCross = []
        self.matrixLabel = []
        self.matrixHBox = []
        self.matrixNrLock =  [5,9,6,10,7,12,1,0,2,3,11,8,13,14,4]
        self.matrixNrLock2 = [7,6,8,9,14,0,2,4,11,1,3,10,5,12,13]
        self.matrixNrLock3 =  [5,9,6,10,7,12,1,0,2,3,11,8,13,14,4]
        self.matrixNrCross =  [5,9,10,1,11,6,7,0,8,12,2,13,3,14,4]
        self.matrixNrCross2 =  [7,3,10,12,14,0,5,6,8,1,2,4,9,11,13]

        #baselines are 1-2, 1-3, 1-4, 1-5, 1-6, 2-3, 2-4, 2-5, 2-6, 3-4, 3-5, 3-6, 4-5, 4-6, 5-6
        self.baselines = [self.beamOrderDict['1']+self.beamOrderDict['2'], self.beamOrderDict['1']+self.beamOrderDict['3'],
                        self.beamOrderDict['1']+self.beamOrderDict['4'], self.beamOrderDict['1']+self.beamOrderDict['5'],
                        self.beamOrderDict['1']+self.beamOrderDict['6'], self.beamOrderDict['2']+self.beamOrderDict['3'],
                        self.beamOrderDict['2']+self.beamOrderDict['4'], self.beamOrderDict['2']+self.beamOrderDict['5'],
                        self.beamOrderDict['2']+self.beamOrderDict['6'], self.beamOrderDict['3']+self.beamOrderDict['4'],
                        self.beamOrderDict['3']+self.beamOrderDict['5'], self.beamOrderDict['3']+self.beamOrderDict['6'],
                        self.beamOrderDict['4']+self.beamOrderDict['5'], self.beamOrderDict['4']+self.beamOrderDict['6'],
                        self.beamOrderDict['5']+self.beamOrderDict['6']]
                        
        self.weightLabels = [self.baselines[0], self.baselines[1], self.baselines[2], self.baselines[3], self.baselines[4], 
                            self.baselines[0], self.baselines[5], self.baselines[6], self.baselines[7], self.baselines[8],
                            self.baselines[1], self.baselines[5], self.baselines[9], self.baselines[10], self.baselines[11],
                            self.baselines[2], self.baselines[6], self.baselines[9], self.baselines[12], self.baselines[13],
                            self.baselines[3], self.baselines[7], self.baselines[10], self.baselines[12], self.baselines[14],
                            self.baselines[4], self.baselines[8], self.baselines[11], self.baselines[13], self.baselines[14]]
        self.weightPairs = [5, 10, 15, 20, 25,
                            0, 11, 16, 21, 26,
                            1, 6, 17, 22, 27,
                            2, 7, 12, 23, 28,
                            3, 8, 13, 18, 29,
                            4, 9, 14, 19, 24]
            
        for i in range(self.nDelayLines):
            self.posiEntry.append(gtk.Entry())
            self.entrySteps.append(gtk.Entry())
            txt = "DELAY LINE %s: beam " %(self.telNames[i])
            label = gtk.Label()
            label.set_markup('<b>%s</b>' %txt)
            label.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            hbox = gtk.HBox(False,0)
            hbox.pack_start(label, False, False, 0)
            table.attach(hbox,
                        # X direction #          # Y direction
                        0, 6,                      i*4+1, i*4+2,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            self.beam.append(gtk.Entry())
            self.beam[i].set_text(self.beamOrder[i])
            self.beam[i].set_size_request(2*scale, 2*scale)
            self.beam[i].connect("activate", self.manualBeamSet, i)
            self.beam[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            #self.beam[i].set_editable(False)
            hbox.pack_start(self.beam[i], False, False, 0)

            button = gtk.CheckButton('use this tel')
            button.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            button.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))
            button.set_active(self.activeTel[i])
            button.connect("toggled", self.setActiveTel, i)
            #button.set_size_request(8*scale, 2*scale)
            hbox.pack_start(button, False, False, 10)

            if i == 0:
                refTelButton = gtk.RadioButton(None, 'reference tel')
                refTelButton.set_active(self.refTel[i])
            else: refTelButton = gtk.RadioButton(refTelButton, 'reference tel')
            refTelButton.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))    
            refTelButton.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse(self.colorDict[self.telNames[i]]))    
            refTelButton.connect("toggled", self.setRefTel, i)
            #refTelButton.set_size_request(10*scale, 2*scale)
            hbox.pack_start(refTelButton, False, False, 0)

            self.fringeDetected.append(gtk.Frame())
            image = fringeIcons.makeIcon('grey')
            self.fringeDetected[i].add(image)
            #self.fringeDetected[i].set_size_request(2*scale, 2*scale)
            hbox.pack_start(self.fringeDetected[i], False, False, 0)
        

            button = gtk.Button('ZERO')
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "zero", i)
            table.attach(button,
                        # X direction #          # Y direction
                        0, 1,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);
            button = create_double_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            #button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "fastLeft", i)
            table.attach(button,
                        # X direction #          # Y direction
                        1, 2,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            button = create_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "left", i)
            table.attach(button,
                        # X direction #          # Y direction
                        2, 3,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            self.posiEntry[i].set_editable(True)
            self.posiEntry[i].connect('activate', self.setManualOffset, i)
            self.posiEntry[i].set_text(str(self.Relative[i]))
            self.posiEntry[i].set_size_request(8*scale, 2*scale)
            table.attach(self.posiEntry[i],
                        # X direction #          # Y direction
                        3, 4,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            button = create_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "right", i)
            table.attach(button,
                        # X direction #          # Y direction
                        4, 5,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            button = create_double_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.set_size_request(4*scale, 2*scale)
            button.connect("clicked", self.move_cb, "fastRight", i)
            table.attach(button,
                        # X direction #          # Y direction
                        5, 6,                      i*4+2, i*4+3,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            
            frame = gtk.Frame("STEP SIZE")
            
            self.entrySteps[i].set_size_request(6*scale, 2*scale)
            self.entrySteps[i].set_text(str(self.steps[i]))
            self.entrySteps[i].connect("activate", self.enter_callback, i)
            frame.add(self.entrySteps[i])
            table.attach(frame,
                        # X direction #          # Y direction
                        0, 1,                      i*4+3, i*4+4,
                        0,     0,
                        0,                         0);
            
            self.loopMinusButton.append(gtk.ToggleButton('LOOP -'))
            #self.loopMinusButton[i].set_size_request(6*scale, 2*scale)
            self.loopMinusButton[i].modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
            self.loopMinusButton[i].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
            self.loopMinusButton[i].connect('clicked', self.startLoop, 'minus', i)
            table.attach(self.loopMinusButton[i],
                        # X direction #          # Y direction
                        1, 2,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);

            self.loopPlusButton.append(gtk.ToggleButton('LOOP +'))
            #self.loopPlusButton[i].set_size_request(6*scale, 2*scale)
            self.loopPlusButton[i].modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
            self.loopPlusButton[i].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
            self.loopPlusButton[i].connect('clicked', self.startLoop, 'plus', i)
            table.attach(self.loopPlusButton[i],
                        # X direction #          # Y direction
                        2, 3,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);
            
            button = gtk.CheckButton('threshold check')
            button.set_active(self.checkThreshold[i])
            button.modify_text(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[i]))    
            button.modify_text(gtk.STATE_PRELIGHT, gtk.gdk.color_parse(self.telColor[i]))    
            button.connect("toggled", self.checkThreshButton, i)
            #button.set_size_request(12*scale, 2*scale)
            table.attach(button,
                        # X direction #          # Y direction
                        4, 6,                      i*4+3, i*4+4,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);

            sep = gtk.VSeparator()
            sep.set_size_request(2*scale, 2*scale)
            table.attach(sep,
                        # X direction #          # Y direction
                        6, 7,                      i*4+1, i*4+5,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            sep = gtk.HSeparator()
            sep.set_size_request(6*scale, 2*scale)
            table.attach(sep,
                        # X direction #          # Y direction
                        0, 6,                      i*4+4, i*4+5,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);


        label = gtk.Label("BASELINES")
        table.attach(label,
                    # X direction #          # Y direction
                    7, 9,                      1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("OPD")
        table.attach(label,
                    # X direction #          # Y direction
                    9, 10,                      1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("WEIGHT")
        table.attach(label,
                    # X direction #          # Y direction
                    10, 11,                      1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("THRESHOLD")
        table.attach(label,
                    # X direction #          # Y direction
                    11, 12,                     1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        label = gtk.Label("                          LOCK")
        table.attach(label,
                    # X direction #          # Y direction
                    12, 14,                     1, 2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);
        

        #SK: generate telescope matrix with weights
        #0 W1 S2
        #1 W1 S1
        #2 W1 E1
        #3 W1 E2
        #4 W1 W2
        #5 S2 S1
        #6 S2 E1
        #7 S2 E2
        #8 S2 W2
        #9 S1 E1
        #10 S1 E2
        #11 S1 W2
        #12 E1 E2
        #13 E1 W2
        #14 E2 W2
        
        #*** Top label
        matrixCrosscount = 0
        matrixSolvecount = 0
        matrixLockcount = 0
        matrixHBoxcount = 0
        
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        label = gtk.Label("")
        self.matrixHBox[matrixHBoxcount].pack_start(label, False, False, 0)
        label = gtk.Label("")
        self.matrixHBox[matrixHBoxcount].pack_start(label, False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[0] = gtk.Label("S1")
        self.matrixLabel[0].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[0]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[0], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[1] = gtk.Label("S2")
        self.matrixLabel[1].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[1]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[1], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[2] = gtk.Label("E1")
        self.matrixLabel[2].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[2]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[2], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[3] = gtk.Label("E2")
        self.matrixLabel[3].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[3]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[3], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[4] = gtk.Label("W1")
        self.matrixLabel[4].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[4]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[4], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[5] = gtk.Label("W2")
        self.matrixLabel[5].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[5]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[5], False, False, 0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     21,22,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        #*** S1
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     22,23,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('SOLVE')
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[6] = gtk.Label("S1")
        self.matrixLabel[6].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[0]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[6], False, False, 0)
        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[7] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[7], False, False, 0)


        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 5)   #S2S1=5
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 9)   #E1S1=9
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 10)  #E2S1=10
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 1)   #W1S1=1
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 11)  #W2S1=11
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)



        #*** S2
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     23,24,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('SOLVE')
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[8] = gtk.Label("S2")
        self.matrixLabel[8].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[1]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[8], False, False, 0)

        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 5)                         #S1S2=5
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[9] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[9], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 6)   #E1S2=6
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 7)   #E2S2=7
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 0)   #W1S2=0
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 8)   #W2S2=8
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)



        #*** E1
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     24,25,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('SOLVE')
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[10] = gtk.Label("E1")
        self.matrixLabel[10].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[2]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[10], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 9)                         #S1E1=9
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 6)                         #S2E1=6
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[11] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[11], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 12)  #E2E1=12
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 2)   #W1E1=2
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 13)  #W2E1=13
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)



        #*** E2
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     25,26,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('SOLVE')
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[12] = gtk.Label("E2")
        self.matrixLabel[12].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[3]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[12], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 10)                        #S1E2=10
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 7)                         #S2E2=7
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 12)                        #E1E2=12
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[13] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[13], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 3)   #W1E2=3
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)

        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 14)  #W2E2=14
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)




        #*** W1
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     26,27,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('SOLVE')
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[14] = gtk.Label("W1")
        self.matrixLabel[14].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[4]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[14], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 1)                         #S1W1=1
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 0)                         #S2W1=0
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 2)                         #E1W1=2
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 3)                         #E2W1=3
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[15] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[15], False, False, 0)


        matrixCrosscount = matrixCrosscount+1
        self.matrixCross.append(gtk.Button())
        self.matrixCross[matrixCrosscount].set_size_request(75, 28)
        self.matrixCross[matrixCrosscount].connect("clicked", self.matrixCrossClick, matrixCrosscount, 4)   #W2W1=4
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixCross[matrixCrosscount], False, False, 0)




        #*** W2
        matrixHBoxcount = matrixHBoxcount+1
        self.matrixHBox.append(gtk.HBox)
        self.matrixHBox[matrixHBoxcount] = gtk.HBox(True,0)
        table.attach(self.matrixHBox[matrixHBoxcount],
                     # X direction #          # Y direction
                     8,14,                     27,28,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        matrixSolvecount = matrixSolvecount+1
        self.matrixSolve.append(gtk.Button())
        self.matrixSolve[matrixSolvecount] = gtk.Button('SOLVE')
        self.matrixSolve[matrixSolvecount].connect("clicked", self.matrixSolveClick, matrixSolvecount)
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixSolve[matrixSolvecount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[16] = gtk.Label("W2")
        self.matrixLabel[16].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.telColor[5]))
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[16], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 11)                        #S1W2=11
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 8)                         #S2W2=8
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 13)                        #E1W2=13
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 14)                        #E2W2=14
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)
        
        matrixLockcount = matrixLockcount+1
        self.matrixLock.append(gtk.Button())
        self.matrixLock[matrixLockcount] = gtk.ToggleButton('')
        self.matrixLock[matrixLockcount].set_size_request(75, 28)
        self.matrixLock[matrixLockcount].connect("clicked", self.matrixLockClick, matrixLockcount, 4)                         #W1W2=4
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLock[matrixLockcount], False, False, 0)

        self.matrixLabel.append(gtk.Label())
        self.matrixLabel[17] = gtk.Label("-")
        self.matrixHBox[matrixHBoxcount].pack_start(self.matrixLabel[17], False, False, 0)



        button = gtk.Button('QUERY TIPTILT')
        button.set_size_request(4*scale, 3*scale)
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', self.updateTiptilt)
        table.attach(button,
                    # X direction #          # Y direction
                    0, 2,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);

        button = gtk.Button('GET OFFSETS')
        button.set_size_request(4*scale, 3*scale)
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', self.getOffsets)
        table.attach(button,
                    # X direction #          # Y direction
                    2, 4,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);

        frame = gtk.Frame('SLEEP TIME')
        sleepEntry= gtk.Entry()
        sleepEntry.set_size_request(4*scale, 2*scale)
        frame.add(sleepEntry)
        sleepEntry.connect("activate", self.enterTime)
        sleepEntry.set_text('0.5')
        self.sleepTime = 1.0
        table.attach(frame,
                    # X direction #          # Y direction
                    4, 6,                      self.nDelayLines*4+1, self.nDelayLines*4+2,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);

        c = [[1, 2],[1, 3],[1, 4],[1, 5],[1, 6],[2, 3],[2, 4],[2, 5],[2, 6],[3, 4],[3, 5],[3, 6],[4, 5],[4, 6],[5, 6]]
        for k in range(self.nBaselines):
            self.baselineLabel1.append(gtk.Label())
            txt = self.beamOrderDict[str(c[k][0])]
            self.baselineLabel1[k].set_markup('<b>%s</b>' %txt)            
            self.baselineLabel1[k].modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.colorDict[self.beamOrderDict[str(c[k][0])]]))
            table.attach(self.baselineLabel1[k],
                        # X direction #          # Y direction
                        7, 8,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.baselineLabel2.append(gtk.Label())
            txt = self.beamOrderDict[str(c[k][1])]
            self.baselineLabel2[k].set_markup('<b>%s</b>' %txt)            
            self.baselineLabel2[k].modify_fg(gtk.STATE_NORMAL, \
                                        gtk.gdk.color_parse(self.colorDict[self.beamOrderDict[str(c[k][1])]]))
            table.attach(self.baselineLabel2[k],
                        # X direction #          # Y direction
                        8, 9,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);

            self.opdEntry.append(gtk.Entry())
            self.opdEntry[k].set_size_request(4*scale, 2*scale)
            table.attach(self.opdEntry[k],
                        # X direction #          # Y direction
                        9, 10,                      2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            
            self.weightEntry.append(gtk.Entry())
            self.weightEntry[k].set_size_request(4*scale, 2*scale)
            table.attach(self.weightEntry[k],
                        # X direction #          # Y direction
                        10, 11,                      2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.thresholdEntry.append(gtk.Entry())
            self.thresholdEntry[k].set_size_request(4*scale, 2*scale)
            self.thresholdEntry[k].set_text(str(self.threshold[k]))
            self.thresholdEntry[k].connect("activate", self.enterThreshold, k)
            table.attach(self.thresholdEntry[k],
                        # X direction #          # Y direction
                        11, 12,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.thresholdCalc.append(gtk.Button('CALC THRESH'))
            self.thresholdCalc[k].set_size_request(6*scale, 4*scale)
            self.thresholdCalc[k].connect("clicked", self.autoThreshCalc, k)
            table.attach(self.thresholdCalc[k],
                        # X direction #          # Y direction
                        12, 13,                     2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);
            self.lockFringes.append(gtk.CheckButton())
            self.lockFringes[k].set_size_request(0*scale, 2*scale)
            self.lockFringes[k].connect("toggled", self.setLockFringes, k)
            print k, self.beamOrderDict[str(c[k][0])], self.beamOrderDict[str(c[k][1])]
            table.attach(self.lockFringes[k],
                        # X direction #          # Y direction
                        13, 14,                   2+k, 3+k,
                        gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                        0,                         0);

        button = gtk.Button('GET FRINGE INFO')
        button.connect('clicked', self.getFringeInfo)
        table.attach(button,
            # X direction #          # Y direction
            9, 10,                      18, 19,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.ToggleButton('START LOOP')
        button.connect('clicked', self.startGDTLoop)
        button.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("yellow"))
        table.attach(button,
            # X direction #          # Y direction
            10, 11,                     18, 19,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.ToggleButton('LOCK FRINGES')
        button.connect('toggled', self.lockFringesToggled)
        table.attach(button,
            # X direction #          # Y direction
            9, 10,                    19, 20,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        button.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("orange"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("yellow"))
        
        button = gtk.Button('SEND GDT INFO')
        button.connect('clicked', self.sendGdtInfo)
        table.attach(button,
            # X direction #          # Y direction
            10, 11,                    19, 20,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        #SK: make buttons for threshold
        button = gtk.Button('CALC ALL')
        #button.set_size_request(6*scale, 4*scale)
        button.connect('clicked', self.autoThreshCalcAll)
        table.attach(button,
            # X direction #          # Y direction
            12, 13,                     18, 19,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('UPDATE THRESH')
        #button.set_size_request(6*scale, 4*scale)
        button.connect('clicked', self.autoThreshUpdate)
        table.attach(button,
            # X direction #          # Y direction
            12, 13,                     19, 20,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        frame = gtk.Frame('SEARCH THRESH. FACTOR')
        autoThreshFactorEntry = gtk.Entry()
        autoThreshFactorEntry.set_size_request(scale, 2*scale)
        frame.add(autoThreshFactorEntry)
        autoThreshFactorEntry.connect("activate", self.autoThreshFactor)
        autoThreshFactorEntry.set_text('5')
        table.attach(frame,
                    # X direction #          # Y direction
                    11, 12,                    18, 19,
                    gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                    0,                         0);


        button = gtk.Button('CLOSE')
        button.set_size_request(4*scale, 3*scale)
        button.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
        button.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.color_parse("orange"))
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            0, 2,                      self.nDelayLines*4+2, self.nDelayLines*4+3,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()


        self.show_all()

    def matrixLockClick(self, widget, ndx, baseline):
        print "Lock baseline #", baseline
        k = 0
        for i in range(6):
            for j in range(i+1, 6):
                try:
                    telcombo = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                    loc = self.baselines.index(telcombo)
                except:
                    telcombo = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                    loc = self.baselines.index(telcombo)
#                print "HERE1", k, ndx, telcombo, loc, baseline
                common.gdtInfo[k+1]= self.lockFringes[loc].get_active()
                k += 1
                self.lockFringes[loc].set_active(self.matrixLock[self.matrixNrLock2[loc]].get_active())
        self.ircc.sendGdtInfo()   #SK: ACTIVATE

    def matrixCrossClick(self, widget, ndx, baseline):
        self.matrixCross[ndx].set_label('')
        #self.matrixSolve.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("red"))
        #self.matrixSolve.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("orange"))

    def matrixSolveClick(self, widget, ndx):
        print "Solve ", ndx
        #self.matrixSolve.set_label('')
        #self.matrixSolve.modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("red"))
        #self.matrixSolve.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("orange"))

    def getpositel1(self, ndx):
        if (ndx == 0):  #W1S2
            positel1 = 4
            positel2 = 1
        if (ndx == 1):  #W1S1
            positel1 = 4
            positel2 = 0
        if (ndx == 2):  #W1E1
            positel1 = 4
            positel2 = 2
        if (ndx == 3):  #W1E2
            positel1 = 4
            positel2 = 3
        if (ndx == 4):  #W1W2
            positel1 = 4
            positel2 = 5
        if (ndx == 5):  #S2S1
            positel1 = 1
            positel2 = 0
        if (ndx == 6):  #S2E1
            positel1 = 1
            positel2 = 2
        if (ndx == 7):  #S2E2
            positel1 = 1
            positel2 = 3
        if (ndx == 8):  #S2W2
            positel1 = 1
            positel2 = 5
        if (ndx == 9):  #S1E1
            positel1 = 0
            positel2 = 2
        if (ndx == 10):  #S1E2
            positel1 = 0
            positel2 = 3
        if (ndx == 11):  #S1W2
            positel1 = 0
            positel2 = 5
        if (ndx == 12):  #E1E2
            positel1 = 2
            positel2 = 3
        if (ndx == 13):  #E1W2
            positel1 = 2
            positel2 = 5
        if (ndx == 14):  #E2W2
            positel1 = 3
            positel2 = 5
        return positel1
        

    def getpositel2(self, ndx):
        if (ndx == 0):  #W1S2
            positel1 = 4
            positel2 = 1
        if (ndx == 1):  #W1S1
            positel1 = 4
            positel2 = 0
        if (ndx == 2):  #W1E1
            positel1 = 4
            positel2 = 2
        if (ndx == 3):  #W1E2
            positel1 = 4
            positel2 = 3
        if (ndx == 4):  #W1W2
            positel1 = 4
            positel2 = 5
        if (ndx == 5):  #S2S1
            positel1 = 1
            positel2 = 0
        if (ndx == 6):  #S2E1
            positel1 = 1
            positel2 = 2
        if (ndx == 7):  #S2E2
            positel1 = 1
            positel2 = 3
        if (ndx == 8):  #S2W2
            positel1 = 1
            positel2 = 5
        if (ndx == 9):  #S1E1
            positel1 = 0
            positel2 = 2
        if (ndx == 10):  #S1E2
            positel1 = 0
            positel2 = 3
        if (ndx == 11):  #S1W2
            positel1 = 0
            positel2 = 5
        if (ndx == 12):  #E1E2
            positel1 = 2
            positel2 = 3
        if (ndx == 13):  #E1W2
            positel1 = 2
            positel2 = 5
        if (ndx == 14):  #E2W2
            positel1 = 3
            positel2 = 5
        return positel2


    def setManualOffset(self, widget, ndx):
        manualOffset = float(widget.get_text())
        print manualOffset
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = manualOffset-self.Absolute[ndx]
        self.posiEntry[ndx].set_text("%10.3f" %(manualOffset))
        self.moveRelative()
        try:
            self.ircc.getFringeInfo()
        except:
            pass
        
        
    def move_cb(self, widget, status, ndx):
        print "status = ", status
        coeff = 10
        self.ircc.getDelayLinesOffsets()
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = 0.

        if (status == "fastLeft"):
                self.Relative[ndx] -= coeff*self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "left"):
                self.Relative[ndx] -= self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "zero"):
                self.Relative[ndx] = -self.Absolute[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "right"):
                self.Relative[ndx] += self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        elif (status == "fastRight"):
                self.Relative[ndx] += coeff*self.steps[ndx]
                self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                self.moveRelative()
        self.getFringeInfo()

    def moveRelative(self):
        common.updatedOffsets = self.Relative.copy()*0.001
        self.Relative = 0.*self.Relative
        self.ircc.sendUpdatedOffsets()

    def sendToOple(self, widget):
        self.ircc.sendToOple()

    def getOffsets(self, widget):
        self.ircc.getDelayLinesOffsets()
        for ndx in range(self.nDelayLines):
            self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
            self.posiEntry[ndx].set_text("%10.3f" %(self.Absolute[ndx]))
        
    def checkThreshButton(self, widget, ndx):
        self.checkThreshold[ndx] = widget.get_active()
        print self.checkThreshold
            
    def setActiveTel(self, widget, ndx):
        self.activeTel[ndx] = widget.get_active()
        common.activeTel = self.activeTel
        self.beamInUse = []
        for i in range(self.nDelayLines):
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
                
        for i in range(6):
            if (self.activeTel[i] == True):
                self.matrixHBox[i+1].show()
                self.matrixSolve[i].show()
                self.matrixLabel[i].show()
                self.matrixLabel[6+2*i].show()
                self.matrixLabel[6+2*i+1].show()
            else:
                self.matrixHBox[i+1].hide()
                self.matrixSolve[i].hide()
                self.matrixLabel[i].hide()
                self.matrixLabel[6+2*i].hide()
                self.matrixLabel[6+2*i+1].hide()
                
        for i in range(self.nBaselines):
            Nr = self.getpositel1(self.matrixNrLock[i])
            Nr2 = self.getpositel2(self.matrixNrLock[i])
            if (self.activeTel[Nr] == True) and (self.activeTel[Nr2] == True):
                self.matrixLock[i].show()
            else:
                self.matrixLock[i].hide()

            Nr = self.getpositel1(self.matrixNrCross[i])
            Nr2 = self.getpositel2(self.matrixNrCross[i])
            if (self.activeTel[Nr] == True) and (self.activeTel[Nr2] == True):
                self.matrixCross[i].show()
            else:
                self.matrixCross[i].hide()
                
        self.beamInUse.sort()
        self.findActiveLocs()
            
    def setRefTel(self, widget, ndx):
        self.refTel[ndx] = widget.get_active()

        #color the reference cart buttons
        refTelNr = 0
        if (self.refTel[0] == True): refTelNr = 0
        if (self.refTel[1] == True): refTelNr = 1
        if (self.refTel[2] == True): refTelNr = 2
        if (self.refTel[3] == True): refTelNr = 3
        if (self.refTel[4] == True): refTelNr = 4
        if (self.refTel[5] == True): refTelNr = 5
        for i in range(self.nBaselines):
            if (self.getpositel1(self.matrixNrCross[i]) == refTelNr) or (self.getpositel2(self.matrixNrCross[i]) == refTelNr):
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("darkgrey"))
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("darkgrey"))
            else:
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
                self.matrixCross[i].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))

            
    def enterTime(self, widget):
        self.sleepTime = float(widget.get_text())
        print "New sleep time: ", self.sleepTime
        
    def enter_callback(self, widget, ndx):
        entry_text = self.entrySteps[ndx].get_text()
        self.steps[ndx] = float(entry_text)
        print "New step size: ", self.steps[ndx]

    def enterThreshold(self, widget, ndx):
        entry_text = widget.get_text()
        self.threshold[ndx] = float(entry_text)
        print "New threshold: ", self.threshold[ndx]

        #SK: send all thresholds
        for n in range(15):
            common.autoThresh[n] = float(self.threshold[n])
        self.ircc.sendautoThresh()


    def findActiveLocs(self):
        k = 0
        activeLocs = na.zeros(self.nBaselines)
        ntels = self.baselineBeam[len(common.opds)]
        ntels = len(self.beamInUse)
        print "ntels = ", ntels
        for i in range(ntels):
            for j in range(i+1, ntels):
                try:
                    wght = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                    loc = self.baselines.index(wght)
                except:
                    wght = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                    loc = self.baselines.index(wght)
##                 print self.beamOrderDict, k, loc, wght, self.beamInUse
                activeLocs[k] = loc        
                k+=1
        print activeLocs
        print activeLocs[:ntels*(ntels-1)/2]
        for i in range(self.nBaselines):
            if i in activeLocs[:ntels*(ntels-1)/2]:
                #print "must show line", i
                self.baselineLabel1[i].show()
                self.baselineLabel2[i].show()
                self.weightEntry[i].show()
                self.opdEntry[i].show()
                self.thresholdEntry[i].show()
                self.lockFringes[i].show()
                self.thresholdCalc[i].show()
            else:
                #print "must delete line", i
                self.baselineLabel1[i].hide()
                self.baselineLabel2[i].hide()
                self.weightEntry[i].hide()
                self.opdEntry[i].hide()
                self.thresholdEntry[i].hide()
                self.lockFringes[i].hide()
                self.thresholdCalc[i].hide()
            
        
        #print "activeLocs = ", activeLocs

    def startLoop(self, widget, sign, ndx):
        loopStatus = widget.get_active()
        if self.loopDLFlag[ndx]:
            if self.loopSign[ndx]!= sign:
                if widget == self.loopPlusButton[ndx]:
                    print "plus"
                    self.loopMinusButton[ndx].set_active(False)
                elif widget == self.loopMinusButton[ndx]:
                    print "minus"
                    self.loopPlusButton[ndx].set_active(False)
                else:
                    print "Does not work!"
        self.loopDLFlag[ndx] = widget.get_active()
        self.loopSign[ndx] = sign
#        print "HERE2", self.loopDLFlag.count(True)
        if self.loopDLFlag.count(True) > 0:
            if self.loopDLTag == -1:
#                print "HERE3", ndx
                self.updateDLTag = gobject.idle_add(self.loopDelayLine)
                self.loopDLTag = 1
        else:
            gobject.source_remove(self.updateDLTag)
            self.loopDLTag = -1


    def loopDelayLine(self):
#        print "HERE4"
        self.ircc.getDelayLinesOffsets()
        
        #for all the delay lines, check if a loop+ or lopp- is running
        for ndx in range(self.nDelayLines):
            if self.loopDLFlag[ndx] == True:
                #if looping then moves the delay line
                self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
                self.Relative[ndx] = 0.
                if self.loopSign[ndx] == 'minus':
                    self.Relative[ndx] -= self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    self.moveRelative()
                elif self.loopSign[ndx] == 'plus':
                    self.Relative[ndx] += self.steps[ndx]
                    self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
                    self.moveRelative()
                self.getFringeInfo(None)        
                
                k = 0
                ntels = len(self.beamInUse)

                #for all the baselines where ndx is check if fringes are detected
                for i in range(ntels):
                    beamInUse_i = self.beamInUse[i]
                    for j in range(i+1, ntels):
                        beamInUse_j = self.beamInUse[j]
                        # if one of the beam corresponds to delay line ndx, then check for fringes
                        if ((beamInUse_i == self.beamOrder[ndx]) or (beamInUse_j == self.beamOrder[ndx])):
                            try:
                                telcombo = self.beamOrderDict[beamInUse_i]+self.beamOrderDict[beamInUse_j]
                                loc = self.baselines.index(telcombo)
                            except:
                                telcombo = self.beamOrderDict[beamInUse_j]+self.beamOrderDict[beamInUse_i]
                                loc = self.baselines.index(telcombo)
                            #check if there are fringes for any baseline with delay line ndx
                            if (common.weights[k] >= (self.threshold[loc]*self.thresholdfactor)):
                                #if there are fringes and the threshold is True then stop the loop for DL ndx12    
                                if self.checkThreshold[ndx] == True:
                                    self.loopPlusButton[ndx].set_active(False)
                                    self.loopMinusButton[ndx].set_active(False)
                                    self.loopDLFlag[ndx] = False
                        k+=1
        
        if (self.loopDLFlag.count(True) > 0) :
            time.sleep(self.sleepTime)
            return True
	
    def getFringeInfo(self, widget = None):
        self.ircc.getFringeInfo()
        for k in range(6):
            self.fringeDetected[k].remove(self.fringeDetected[k].child)
            image = fringeIcons.makeIcon('grey')
            image.show()
            self.fringeDetected[k].add(image)
            
        for k in range(self.nBaselines):
            self.opdEntry[k].set_text('')
            self.weightEntry[k].set_text('')
            self.weightEntry[k].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("grey"))
        k = 0
        ntels = self.baselineBeam[len(common.opds)]
        ntels = len(self.beamInUse)
        if ntels < 2:
            print "can't make fringes with only one telescope"
        else:
            for i in range(ntels):
                for j in range(i+1, ntels):
                    try:
                        telcombo = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                        loc = self.baselines.index(telcombo)
                    except:
                        telcombo = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                        loc = self.baselines.index(telcombo)
                    #pdb.set_trace()
                    self.opdEntry[loc].set_text("%i" %(int(common.opds[k])))          #10.3
                    self.weightEntry[loc].set_text("%i" %(int(common.weights[k])))    #10.3
                    #SK:
                    self.matrixLock[self.matrixNrLock2[loc]].set_label("%10.1f" %(common.weights[loc]/(self.threshold[loc]*self.thresholdfactor)))
                    self.matrixLock[self.matrixNrLock2[loc]].set_active(self.lockFringes[loc].get_active())
                    if (common.weights[loc]/(self.threshold[loc]*self.thresholdfactor)>=1):
                        self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("green"))
                        self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("yellow"))
                    if (common.weights[loc]/(self.threshold[loc]*self.thresholdfactor)<1):
                        self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_ACTIVE, gtk.gdk.color_parse("pink"))
#SK2                        if 
                        refTelNr = 0
                        if (self.refTel[0] == True): refTelNr = 0
                        if (self.refTel[1] == True): refTelNr = 1
                        if (self.refTel[2] == True): refTelNr = 2
                        if (self.refTel[3] == True): refTelNr = 3
                        if (self.refTel[4] == True): refTelNr = 4
                        if (self.refTel[5] == True): refTelNr = 5
                        if (self.getpositel1(loc) == refTelNr) or (self.getpositel2(loc) == refTelNr):
                            self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('darkgrey'))
                        else:
                            self.matrixLock[self.matrixNrLock2[loc]].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
                    if (common.weights[loc]/(self.threshold[loc]*self.thresholdfactor) > 1.):
                        posicross = (float(self.posiEntry[self.getpositel2(loc)].get_text()) - float(self.posiEntry[self.getpositel1(loc)].get_text()))
                        self.matrixCross[self.matrixNrCross2[loc]].set_label("%10.3f" %(posicross))

                        
                    if (common.weights[k] >= self.threshold[loc]*self.thresholdfactor):
                        flag = 1
                        self.weightEntry[loc].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
                        tel = self.beamOrderDict[self.beamInUse[i]]
                        itel = self.telNames.index(tel)
                        image = fringeIcons.makeIcon(tel)
                        image.show()
                        self.fringeDetected[itel].remove(self.fringeDetected[itel].child)
                        self.fringeDetected[itel].add(image)
                        tel = self.beamOrderDict[self.beamInUse[j]]
                        itel = self.telNames.index(tel)
                        image = fringeIcons.makeIcon(tel)
                        image.show()
                        self.fringeDetected[itel].remove(self.fringeDetected[itel].child)
                        self.fringeDetected[itel].add(image)
                    else:
                        self.weightEntry[loc].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#D3D3D3'))
                    k+=1

    def initSocket(self):
        self.sock = None
        for port in range(6):
            for res in socket.getaddrinfo(self.host, self.port+port, socket.AF_UNSPEC, socket.SOCK_STREAM):
                af, socktype, proto, canonname, sa = res
                try:
                    self.sock = socket.socket(af, socktype, proto)
                    self.sock.settimeout(self.sockTimeout)
                except socket.error, msg:
                    self.sock = None
                    continue
                try:
                    self.sock.connect(sa)
                    self.fd = self.sock.fileno()
                except socket.error, msg:
                    self.sock.close()
                    self.sock = None
                    continue
                break
            if self.sock is None:
                print 'could not open socket on port: ', self.port+port
            else:
                break
            
    def queryTiptilt(self):
        self.host = '192.168.3.26'  #tiptilt
        self.port = 2000
        self.initSocket()
        beamOrder = ['1', '2', '3', '4', '5', '6']
        if self.sock == None:
            print "socket frame failed to create"
            return None
        else:
            self.sock.settimeout(5)
            self.sock.send('status')
            length = 0
            l = 10
            data = ''
            while data.find('COMMAND_COMPLETE') == -1:
                message = self.sock.recv(100)
                l = len(message)
                length += l
                data += message
            self.sock.close()
            splitData = data.splitlines()
            tel = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
            for t in range(6):
                for i in range(6):
                    if splitData[i+1].find(tel[t]) != -1:
                        beamOrder[t] = str(i+1)
                        #print str(i+1), beamOrder[t]
                        #print beamOrder
        return beamOrder
    
##     def queryTiptilt(self):
##         return None

    def refreshTiptiltInfo(self):
        self.beamInUse = []
        for i in range(self.nDelayLines):
            self.beam[i].set_text(self.beamOrder[i])
            if self.activeTel[i] == True:
                self.beamInUse.append(self.beamOrder[i])
            self.beamOrderDict[self.beamOrder[i]] = self.telNames[i]
        self.beamInUse.sort()
        #print self.beamOrderDict, self.beamInUse
        
    def updateTiptilt(self,widget):
        self.beamOrder = self.queryTiptilt()
        if self.beamOrder == None:
            self.beamOrder = ['1', '2', '3', '4', '5', '6']
        self.refreshTiptiltInfo()
            
    def setLockFringes(self, widget, ndx):
        #pdb.set_trace()
        print "common.gdtInfo = ", common.gdtInfo
        ntels = self.baselineBeam[len(common.opds)]
        k = 0
        for i in range(ntels):
            for j in range(i+1, ntels):
                try:
                    telcombo = self.beamOrderDict[self.beamInUse[i]]+self.beamOrderDict[self.beamInUse[j]]
                    loc = self.baselines.index(telcombo)
                except:
                    telcombo = self.beamOrderDict[self.beamInUse[j]]+self.beamOrderDict[self.beamInUse[i]]
                    loc = self.baselines.index(telcombo)
                common.gdtInfo[k+1]= self.lockFringes[loc].get_active()
#                print "HERE5 ", loc, self.matrixNrLock2[loc]
                self.matrixLock[self.matrixNrLock2[loc]].set_active(self.lockFringes[loc].get_active())
#                print "HERE6 ", loc, self.matrixNrLock2[loc]

        #0 W1 S2
        #1 W1 S1
        #2 W1 E1
        #3 W1 E2
        #4 W1 W2
        #5 S2 S1
        #6 S2 E1
        #7 S2 E2
        #8 S2 W2
        #9 S1 E1
        #10 S1 E2
        #11 S1 W2
        #12 E1 E2
        #13 E1 W2
        #14 E2 W2

                print "CLICK ", ndx, loc, self.matrixNrLock2[loc], self.matrixNrLock2[loc]
                k += 1
        print "common.gdtInfo = ", common.gdtInfo
        self.getFringeInfo()

 
    def lockFringesToggled(self,widget):
        common.gdtInfo[0] = widget.get_active()
        print "common.gdtInfo = ", common.gdtInfo

    def manualBeamSet(self, widget, i):
        self.beamOrder[i] = widget.get_text()
        self.refreshTiptiltInfo()
        
##     def checkButton(self, widget, data=None):
##         common.gdtInfo[self.baseKeyw.index(data)+1] = widget.get_active()
##         print "common.gdtInfo = ", common.gdtInfo
    
            
    def startGDTLoop(self, widget):
        if widget.get_active():
            #pdb.set_trace()
            self.updateGdtTag = gobject.idle_add(self.updateGdt)
            
        else:
            gobject.source_remove(self.updateGdtTag)       

    def sendGdtInfo(self, widget):
        self.ircc.sendGdtInfo()

    def autoThreshCalc(self, widget, ndx):
        print "CALL autoThreshCalc", ndx
        self.ircc.sendautoThreshCalc(ndx)

    def autoThreshUpdate(self, widget):
        print "CALL autoThreshUpdate"
        self.ircc.getautoThresh()
        for n in range(15):
            self.thresholdEntry[n].set_text("%i" %(int(common.thresh[n])))
            self.threshold[n] = common.thresh[n]

    def autoThreshCalcAll(self, widget):
        print "CALL autoThreshCalcAll"
        self.ircc.sendautoThreshCalcAll()

    def autoThreshFactor(self, widget):
        self.thresholdfactor = float(widget.get_text())
        print "CALL autoThreshFactor", self.thresholdfactor
  
    def updateGdt(self):
        self.getFringeInfo(None)
        time.sleep(self.sleepTime)
        return True
        
    
class observationInfo(gtk.Window):
    def __init__(self, parent=None):
        self.ircc = IRCamCommands.IRCamCommands()
        # Create the toplevel window
        gtk.Window.__init__(self)
        
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title(self.__class__.__name__)
## 	self.set_default_size(400, 400)
        
        table = gtk.Table(10, 12, False)
        self.add(table)

        i = 0
        label = gtk.Label('TARGET NAME:')
        table.attach(label,
                    # X direction #          # Y direction
                    0, 1,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);
        self.targetNameEntry = gtk.Entry()
        self.targetNameEntry.set_size_request(60, 20)
        table.attach(self.targetNameEntry,
                    # X direction #          # Y direction
                    1, 3,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);
        self.querySimbadButton = gtk.Button('query SIMBAD')
        self.querySimbadButton.connect('clicked', self.querySimbad)
        self.querySimbadButton.set_size_request(60, 20)
        table.attach(self.querySimbadButton,
                    # X direction #          # Y direction
                    3, 5,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);
        i+=1
                    
        label = gtk.Label('TARGET COORDINATES:')
        table.attach(label,
                    # X direction #          # Y direction
                    0, 1,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);
        self.raEntry= gtk.Entry()
        self.raEntry.set_size_request(60, 20)
        table.attach(self.raEntry,
                    # X direction #          # Y direction
                    1, 3,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);
            
        self.decEntry= gtk.Entry()
        self.decEntry.set_size_request(60, 20)
        table.attach(self.decEntry,
                    # X direction #          # Y direction
                    3, 5,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);            
        i+=1
            
        label = gtk.Label('OBSERVERS:')
        table.attach(label,
                    # X direction #          # Y direction
                    0, 1,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);
        self.observersEntry= gtk.Entry()
        self.observersEntry.set_size_request(60, 20)
        table.attach(self.observersEntry,
                    # X direction #          # Y direction
                    1, 3,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);
            
        i+=1
            
        label = gtk.Label('TELESCOPES:')
        table.attach(label,
                    # X direction #          # Y direction
                    0, 1,                      i,i+1,
                    gtk.EXPAND | gtk.FILL,     0,
                    0,                         0);

        telNames = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
        self.beam = []
        for b in range(6):
            frame = gtk.Frame('Beam '+str(b+1))
            self.beam.append(gtk.combo_box_new_text())
            self.beam[b].set_wrap_width(1)
            self.beam[b].append_text('--')
            for tel in telNames:
                self.beam[b].append_text(tel)
            self.beam[b].connect('changed', self.changedTel, b)
            self.beam[b].set_active(0)
            table.attach(frame,
                        # X direction #          # Y direction
                        1+b, 2+b,                      i,i+1,
                        gtk.EXPAND | gtk.FILL,     0,
                        0,                         0);
            frame.add(self.beam[b])	

        button = gtk.Button('CLOSE')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            5, 7,                      11,12,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()

        self.show_all()

    def changedTel(self, combobox, i):
        model = combobox.get_model()
        index = combobox.get_active()
        if index:
            print 'This is ', model[index][0], '!'
        return 0
    
    def URLName(self, name):
        "Encode special characters in a url string"
        urlname = ''; codes1 = {'+':'%20', ' ':'%20', ',':'%20'}
        codes2 = string.letters + string.digits + '.-'
        for i in name:
            if codes1.has_key(i): urlname = urlname + codes1[i]
            elif i in codes2: urlname = urlname + i
            else: urlname = urlname + "%21"
        return urlname

    def querySimbad(self, include_ref=0, verb=0):
        name = self.targetNameEntry.get_text()
        #print name
        domain = "archive.eso.org"
        url = "/skycat/servers/sim-server?&o="+self.URLName(name)
        h = HTTP(domain)
        h.putrequest('GET', url)
        h.putheader('Accept', 'text/html')
        h.putheader('Accept', 'text/plain'); h.endheaders()
        if verb:
            sys.stderr.write("Submitting request to SIMBAD...\n")
        errcode, errmsg, headers = h.getreply()
        if errcode != 200:
            sys.stderr.write("Error in receiving response from SIMBAD\n")
            return None
        results = h.getfile().readlines()
        if len(results) == 4:
            print results
            res = results[2].split('\n')[0].split('\t')
            name = res[0]
            ra = float(res[1])
            dec = float(res[2])
            #print name, ra, dec
            self.raEntry.set_text(str(ra*12./180))
            self.decEntry.set_text(str(dec))
        else:
            self.raEntry.set_text('N/A')
            self.decEntry.set_text('N/A')
            

tokenDict = {"server": serverParameters, "delayLines2": delayLinesControl2, \
            "gdt2": gdtControl2, "observationInfo":observationInfo}

def main(funct):
    functionToCall = tokenDict[funct]
    functionToCall()
    gtk.main()

if __name__ == '__main__':
    main()

    
## python -c "import childWindows as cw; cw.main('gdt')"
## python -c "import childWindows as cw; cw.main('delayLines')"
