import gtk
import socket
import numarray as  na
import gobject
import copy
import time

import common
import IRCamCommands


def scale_set_default_values(scale):
    scale.set_update_policy(gtk.UPDATE_CONTINUOUS)
    scale.set_digits(1)
    scale.set_value_pos(gtk.POS_TOP)
    scale.set_draw_value(True)

def create_arrow_button(arrow_type, shadow_type):
    button = gtk.Button();
    arrow = gtk.Arrow(arrow_type, shadow_type);
    button.add(arrow)
    button.show()
    arrow.show()
    return button

def create_double_arrow_button(arrow_type, shadow_type):
    button = gtk.Button();
    hbox = gtk.HBox()
    arrow = gtk.Arrow(arrow_type, shadow_type);
    hbox.add(arrow)
    arrow = gtk.Arrow(arrow_type, shadow_type);
    hbox.add(arrow)
    button.add(hbox)
    button.show()
    arrow.show()
    return button

class serverParameters(gtk.Window):
    def __init__(self, parent=None):
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())
            
        self.set_title("server parameters")
	self.set_default_size(150, 200)
        
        table = gtk.Table(1, 3, False)
        self.add(table)

        self.host = common.host
        self.port = common.port

        frame = gtk.Frame("server IP")
        hostEntry = gtk.Entry()
        hostEntry.set_size_request(40, 20)
        hostEntry.set_text(self.host)
        hostEntry.connect("activate", self.serverSetEntry, 'host')
        frame.add(hostEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      0,1,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        frame = gtk.Frame("server port")
        hostEntry = gtk.Entry()
        hostEntry.set_size_request(40, 20)
        hostEntry.set_text(str(self.port))
        hostEntry.connect("activate", self.serverSetEntry, 'port')
        frame.add(hostEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      1,2,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        button = gtk.Button('close')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      2, 3,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
	button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        
        self.show_all()

    def serverSetEntry(self, widget, data):
        entry = widget.get_text()
        if data == 'host':
            self.host = entry
            common.host = self.host
            print "New IP is: ", self.host

        elif data == 'port':
            self.port = int(entry)
            common.port = self.port
            print "New port is: ", self.port
        

class delayLinesControl(gtk.Window):
    def __init__(self, parent=None):
        self.ircc = IRCamCommands.IRCamCommands()
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title(self.__class__.__name__)
	self.set_default_size(400, 400)
        
        table = gtk.Table(10, 40, False)
        self.add(table)

        self.nDelayLines = 6
        
        self.posiEntry = []
        self.entrySteps = []
        self.updateGdtTag = [-1]*6
        self.checkThreshold = [True]*6
        self.threshold = na.array([100.]*self.nDelayLines)
	self.steps = na.array([0.005]*self.nDelayLines)
	self.Relative = na.zeros(self.nDelayLines,  type=na.Float64)
        self.Absolute = na.zeros(self.nDelayLines,  type=na.Float64)
        self.delayLinesID = ['S1', 'S2', 'E1', 'E2', 'W1', 'W2']
	#which baselines participate in which delaylines
        #self.delayLinesWeight = [[1, 3, 5], [2, 4, 5], [], [], [0, 1, 2], [0, 3, 4]]
        #S2E2W1W2 self.delayLinesWeight = [[], [0,1,2], [], [0,3,4], [1,3,5], [2,4,5]]
        #E1E2W2W1
	self.delayLinesWeight = [[],[],[0,1,2], [0,3,4], [2,4,5], [1,3,5]]


        for i in range(self.nDelayLines):
            self.posiEntry.append(gtk.Entry())
            self.entrySteps.append(gtk.Entry())
            label = gtk.Label("DELAY LINE %s" %(self.delayLinesID[i]))
            hbox = gtk.HBox()
            hbox.add(label)
            table.attach(hbox,
                         # X direction #          # Y direction
                         0, 10,                      i*4+1, i*4+2,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            button = gtk.Button('ZERO')
            button.set_size_request(60, 20)
            button.connect("clicked", self.move_cb, "zero", i)
            table.attach(button,
                         # X direction #          # Y direction
                         0, 1,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);
            button = create_double_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            button.connect("clicked", self.move_cb, "fastLeft", i)
            table.attach(button,
                         # X direction #          # Y direction
                         1, 2,                      i*4+2, i*4+3,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            button = create_arrow_button(gtk.ARROW_LEFT, gtk.SHADOW_ETCHED_IN)
            button.connect("clicked", self.move_cb, "left", i)
            table.attach(button,
                         # X direction #          # Y direction
                         2, 3,                      i*4+2, i*4+3,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            
            self.posiEntry[i].set_editable(False)
            self.posiEntry[i].set_text(str(self.Relative[i]))
            self.posiEntry[i].set_size_request(60, 20)
            table.attach(self.posiEntry[i],
                         # X direction #          # Y direction
                         3, 4,                      i*4+2, i*4+3,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            
            button = create_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.connect("clicked", self.move_cb, "right", i)
            table.attach(button,
                         # X direction #          # Y direction
                         4, 5,                      i*4+2, i*4+3,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            
            button = create_double_arrow_button(gtk.ARROW_RIGHT, gtk.SHADOW_ETCHED_IN)
            button.connect("clicked", self.move_cb, "fastRight", i)
            table.attach(button,
                         # X direction #          # Y direction
                         5, 6,                      i*4+2, i*4+3,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            
            
            frame = gtk.Frame("STEP SIZE")
            
            self.entrySteps[i].set_size_request(60, 20)
            self.entrySteps[i].set_text(str(self.steps[i]))
            self.entrySteps[i].connect("activate", self.enter_callback, i)
            frame.add(self.entrySteps[i])
            table.attach(frame,
                         # X direction #          # Y direction
                         0, 1,                      i*4+3, i*4+4,
                         0,     0,
                         0,                         0);
            button = gtk.ToggleButton('LOOP -')
            button.connect('clicked', self.startLoop, 'minus', i)
            table.attach(button,
                         # X direction #          # Y direction
                         1, 2,                      i*4+3, i*4+4,
                         gtk.EXPAND | gtk.FILL,     0,
                         0,                         0);
            
            button = gtk.ToggleButton('LOOP +')
            button.connect('clicked', self.startLoop, 'plus', i)
            table.attach(button,
                         # X direction #          # Y direction
                         2, 3,                      i*4+3, i*4+4,
                         gtk.EXPAND | gtk.FILL,     0,
                         0,                         0);
            
            button = gtk.CheckButton('enable threshold check')
            button.set_active(self.checkThreshold[i])
            button.connect("toggled", self.checkButton, i)
            table.attach(button,
                         # X direction #          # Y direction
                         4, 6,                      i*4+3, i*4+4,
                         gtk.EXPAND | gtk.FILL,     0,
                         0,                         0);

            sep = gtk.HSeparator()
            table.attach(sep,
                         # X direction #          # Y direction
                         0, 10,                      i*4+4, i*4+5,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);

        self.weightEntry = []
        self.thresholdEntry = []
        weightFrame = []
        thresholdFrame = []
#        baselines = ['W1W2', 'W1S1', 'W1S2', 'W2S1', 'W2S2', 'S1S2']
# S2E2W1W2
#        baselines = ['S2E2', 'S2W1', 'S2W2', 'E2W1', 'E2W2', 'W1W2']
# S1E1W1W2
# 	baselines = ['S1E1', 'S1W1', 'S1W2','E1W1','E1W2', 'W1W2']
# E1E2W2W1
        baselines = ['E1E2','E1W2','E1W1','E2W2','E2W1','W2W1']

        for i in range(self.nDelayLines):
            self.weightEntry.append(gtk.Entry())
            self.weightEntry[i].set_size_request(60, 20)
            weightFrame.append(gtk.Frame("weight %s" %(baselines[i])))
            weightFrame[i].add(self.weightEntry[i])
            table.attach(weightFrame[i],
                         # X direction #          # Y direction
                         i, i+1,                      self.nDelayLines*4+3, self.nDelayLines*4+4,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            self.thresholdEntry.append(gtk.Entry())
            self.thresholdEntry[i].set_size_request(60, 20)
            self.thresholdEntry[i].set_text(str(self.threshold[i]))
            self.thresholdEntry[i].connect("activate", self.enterThreshold, i)
            thresholdFrame.append(gtk.Frame('threshold'))
            thresholdFrame[i].add(self.thresholdEntry[i])
            table.attach(thresholdFrame[i],
                         # X direction #          # Y direction
                         i, i+1,                      self.nDelayLines*4+4, self.nDelayLines*4+5,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
        sep = gtk.HSeparator()
        table.attach(sep,
                     # X direction #          # Y direction
                     0, 10,                     self.nDelayLines*4+5, self.nDelayLines*4+6,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);
            
        
        button = gtk.Button('get offsets')
        button.connect('clicked', self.getOffsets)
        table.attach(button,
                     # X direction #          # Y direction
                     0, 2,                      self.nDelayLines*4+6, self.nDelayLines*4+7,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        frame  =gtk.Frame('sleep time')
        sleepEntry= gtk.Entry()
        sleepEntry.set_size_request(120, 20)
        frame.add(sleepEntry)
        sleepEntry.connect("activate", self.enterTime)
        sleepEntry.set_text('1')
        self.sleepTime = 1.0
        table.attach(frame,
                     # X direction #          # Y direction
                     2, 4,                      self.nDelayLines*4+6, self.nDelayLines*4+7,
                     gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                     0,                         0);

        button = gtk.Button('close')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            4, 6,                      self.nDelayLines*4+6, self.nDelayLines*4+7,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
	button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()


        self.show_all()

    def move_cb(self, widget, status, ndx):
    	print "status = ", status
        coeff = 10
        self.ircc.getDelayLinesOffsets()
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = 0.

	if (status == "fastLeft"):
		self.Relative[ndx] -= coeff*self.steps[ndx]
		self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
		self.moveRelative()
	elif (status == "left"):
		self.Relative[ndx] -= self.steps[ndx]
		self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
		self.moveRelative()
	elif (status == "zero"):
		self.Relative[ndx] = -self.Absolute[ndx]
		self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
		self.moveRelative()
	elif (status == "right"):
		self.Relative[ndx] += self.steps[ndx]
		self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
		self.moveRelative()
	elif (status == "fastRight"):
		self.Relative[ndx] += coeff*self.steps[ndx]
		self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
		self.moveRelative()
        self.ircc.getFringeInfo()        
        for i in self.delayLinesWeight[ndx]:
            self.weightEntry[i].set_text("%10.3f" %(common.weights[i]))
            self.weightEntry[i].set_editable(False)

    def moveRelative(self):
        common.updatedOffsets = self.Relative.copy()*0.001
        self.Relative = 0.*self.Relative
        self.ircc.sendUpdatedOffsets()

    def sendToOple(self, widget):
        self.ircc.sendToOple()

    def getOffsets(self, widget):
        self.ircc.getDelayLinesOffsets()
        for ndx in range(self.nDelayLines):
            self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
            self.posiEntry[ndx].set_text("%10.3f" %(self.Absolute[ndx]))
        
    def checkButton(self, widget, ndx):
        self.checkThreshold[ndx] = widget.get_active()
        print self.checkThreshold
            
    def enterTime(self, widget):
	self.sleepTime = float(widget.get_text())
	print "New sleep time: ", self.sleepTime
        
    def enter_callback(self, widget, ndx):
	entry_text = self.entrySteps[ndx].get_text()
	self.steps[ndx] = float(entry_text)
	print "New step size: ", self.steps[ndx]

    def enterThreshold(self, widget, ndx):
	entry_text = widget.get_text()
	self.threshold[ndx] = float(entry_text)
	print "New threshold: ", self.threshold[ndx]


    def startLoop(self, widget, sign, ndx):
        if widget.get_active():
            self.updateGdtTag[ndx] = gobject.idle_add(self.loopDelayLine, widget, sign, ndx)
        else:
            gobject.source_remove(self.updateGdtTag[ndx])

    def loopDelayLine(self, widget, sign, ndx):
        flag = 0
        self.ircc.getDelayLinesOffsets()
        self.Absolute[ndx] = common.delayLinesOffsets[ndx]*1000.
        self.Relative[ndx] = 0.
        if sign == 'minus':
		self.Relative[ndx] -= self.steps[ndx]
		self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
		self.moveRelative()
        elif sign == 'plus':
		self.Relative[ndx] += self.steps[ndx]
		self.posiEntry[ndx].set_text("%10.3f" %(self.Relative[ndx]+self.Absolute[ndx]))
		self.moveRelative()
        self.ircc.getFringeInfo()        
        for i in self.delayLinesWeight[ndx]:
            self.weightEntry[i].set_text("%10.3f" %(common.weights[i]))
            self.weightEntry[i].set_editable(False)
            if (common.weights[i] >= self.threshold[i]):
                flag = 1
        if (flag == 1) and (self.checkThreshold[ndx] == True):
            widget.set_active(False)
        else:
            time.sleep(self.sleepTime)
            return True
            
        
    def getFringeInfo(self, widget):
        self.ircc.getFringeInfo()
        for ndx in range(self.nBaselines):
            self.weightEntry[ndx].set_text("%10.3f" %(common.weights[ndx]))
            self.opdEntry[ndx].set_text("%10.3f" %(common.opds[ndx]))
        


class gdtControl(gtk.Window):
    def __init__(self, parent=None):
        self.ircc = IRCamCommands.IRCamCommands()
        # Create the toplevel window
        gtk.Window.__init__(self)
        
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title(self.__class__.__name__)
## 	self.set_default_size(400, 400)
        
        table = gtk.Table(10, 12, False)
        self.add(table)

        label = gtk.Label('BASELINES')
        table.attach(label,
            # X direction #          # Y direction
            0, 1,                      0,1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        label = gtk.Label('WEIGHT')
        table.attach(label,
            # X direction #          # Y direction
            1, 2,                      0,1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        label = gtk.Label('OPD')
        table.attach(label,
            # X direction #          # Y direction
            2, 3,                      0,1,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        #buttonLabel = ['W1W2', 'W1S1', 'W1S2', 'W2S1', 'W2S2', 'S1S2']
        #['1-2', '1-3', '1-4', '2-3', '2-4', '3-4']
	#S2E2W1W2
        #buttonLabel = ['S2E2', 'S2W1', 'S2W2','E2W1','E2W2', 'W1W2']
	#E1E2W2W1
        buttonLabel = ['E1E2','E1W2','E1W1','E2W2','E2W1','W2W1']

        self.baseKeyw = ['b12', 'b13', 'b14', 'b23', 'b24', 'b34']
        self.weightEntry = []
        self.opdEntry = []
        self.nBaselines = 6
        for i in range(self.nBaselines):
            self.weightEntry.append(gtk.Entry())
            self.opdEntry.append(gtk.Entry())

            button = gtk.CheckButton(buttonLabel[i])
            button.connect("toggled", self.checkButton, self.baseKeyw[i])
            table.attach(button,
                         # X direction #          # Y direction
                         0, 1,                      i+1, i+2,
                         gtk.EXPAND | gtk.FILL,     0,
                         0,                         0);
            self.weightEntry[i].set_editable(False)
            table.attach(self.weightEntry[i],
                         # X direction #          # Y direction
                         1, 2,                      i+1, i+2,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);
            self.opdEntry[i].set_editable(False)
            table.attach(self.opdEntry[i],
                         # X direction #          # Y direction
                         2, 3,                      i+1, i+2,
                         gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                         0,                         0);


        sep = gtk.HSeparator()
        table.attach(sep,
            # X direction #          # Y direction
            0, 10,                      8,9,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        
        button = gtk.Button('SEND GDT INFO')
        button.connect('clicked', self.sendGdtInfo)
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      9, 10,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('GET FRINGE INFO')
        button.connect('clicked', self.getFringeInfo)
        table.attach(button,
            # X direction #          # Y direction
            1, 2,                      9, 10,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.ToggleButton('START LOOP')
        button.connect('clicked', self.startLoop)
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      10, 11,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.ToggleButton('LOCK FRINGES')
        button.connect('toggled', self.lockFringes)
        table.attach(button,
            # X direction #          # Y direction
            1, 2,                      10,11,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('CLOSE')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            0, 2,                      11,12,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);
        
	button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()


        self.show_all()

    def checkButton(self, widget, data=None):
        common.gdtInfo[self.baseKeyw.index(data)+1] = widget.get_active()
        print "common.gdtInfo = ", common.gdtInfo
       
            
    def startLoop(self, widget):
        if widget.get_active():
            self.updateGdtTag = gobject.idle_add(self.updateGdt)
        else:
            gobject.source_remove(self.updateGdtTag)       

    def sendGdtInfo(self, widget):
        self.ircc.sendGdtInfo()

    def getFringeInfo(self, widget):
        self.ircc.getFringeInfo()
        for ndx in range(self.nBaselines):
            self.weightEntry[ndx].set_text("%10.3f" %(common.weights[ndx]))
            self.opdEntry[ndx].set_text("%10.3f" %(common.opds[ndx]))
            
    def lockFringes(self,widget):
        common.gdtInfo[0] = widget.get_active()
        print "common.gdtInfo = ", common.gdtInfo

    def updateGdt(self):
        self.ircc.getFringeInfo()
        for ndx in range(self.nBaselines):
            self.weightEntry[ndx].set_text("%10.3f" %(common.weights[ndx]))
            self.opdEntry[ndx].set_text("%10.3f" %(common.opds[ndx]))
        time.sleep(1)
        return True
    
tokenDict = {"server": serverParameters, "delayLines": delayLinesControl, "gdt": gdtControl}

def main(funct):
    functionToCall = tokenDict[funct]
    functionToCall()
    gtk.main()

if __name__ == '__main__':
    main()

    
## python -c "import childWindows as cw; cw.main('gdt')"
## python -c "import childWindows as cw; cw.main('delayLines')"
