#!/usr/bin/python
'''
the import user command looks for .pythonrc.py and execute it
in our case .pythonrc.py gives acces to the modules from
$HOME/control/python/pythonLibs
'''
import user

import gtk
import numarray as  na
import gobject
import copy
import time
import IRCamLibs.camStructures
import IRCamLibs.IRCamCommands
import IRCamLibs.camStructures
import os as os
import pdb

class pythonConfigParameters(gtk.Window):
    def __init__(self, ircc = None, parent=None):
        if ircc == None: self.ircc = IRCamLibs.IRCamCommands.IRCamCommands()
        else: self.ircc = ircc
        self.ircc.getPythonConfigStruct()

#EP 19Nov07 SUPERKLUDGE !!!!!!!
#since  beamorder not initialised correctly get info from environment var defined in launch script !!!

        if os.getenv('BEAM1'):
            self.ircc.pythonConfig['BeamOrder']=na.array([int(os.environ['BEAM1']),int(os.environ['BEAM2']),int(os.environ['BEAM3']),int(os.environ['BEAM4'])])

# Send values back to RT with beam order from OS (hope this works!)
        self.ircc.sendPythonConfigStruct()

        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title("pythonConfig")
        self.set_default_size(230, 400)

        sw = gtk.ScrolledWindow()
        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.add(sw)

        table = gtk.Table(1, 3, False)
        sw.add_with_viewport(table)

        frame = gtk.Frame("server IP")
        self.hostEntry = gtk.Entry()
        self.hostEntry.set_size_request(40, 20)
        self.hostEntry.set_text(self.ircc.host)
        frame.add(self.hostEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      0,1,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        frame = gtk.Frame("server port")
        self.portEntry = gtk.Entry()
        self.portEntry.set_size_request(40, 20)
        self.portEntry.set_text(str(self.ircc.port))
        frame.add(self.portEntry)
        table.attach(frame,
            # X direction #          # Y direction
            0, 1,                      1,2,
            gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
            0,                         0);

        self.pythonConfigEntries = []
        for ndx, key in enumerate(self.ircc.pythonConfigKeys):
            self.pythonConfigEntries.append(gtk.Entry())
            toString = IRCamLibs.camStructures.pythonConfigToString
            #pdb.set_trace()
            self.pythonConfigEntries[ndx].set_text(toString[ndx](self.ircc.pythonConfig[key]))
            frame = gtk.Frame(key)
            frame.add(self.pythonConfigEntries[ndx])
            table.attach(frame,
                # X direction #          # Y direction
                0, 1,                      2+ndx,3+ndx,
                gtk.EXPAND | gtk.FILL,     gtk.EXPAND | gtk.FILL,
                0,                         0);

        button = gtk.Button('GET VALUES FROM RT')
        button.connect('clicked', self.getValuesFromRt)
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      3+ndx, 4+ndx,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('SEND VALUES TO RT')
        button.connect('clicked', self.sendValuesToRt)
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      4+ndx, 5+ndx,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button = gtk.Button('CLOSE')
        button.connect('clicked', lambda button, w=self: w.destroy())
        table.attach(button,
            # X direction #          # Y direction
            0, 1,                      5+ndx, 6+ndx,
            gtk.EXPAND | gtk.FILL,     0,
            0,                         0);

        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()

        self.show_all()

    def getValuesFromRt(self, widget):
        self.ircc.getPythonConfigStruct()
        for ndx, key in enumerate(self.ircc.pythonConfigKeys):
            toString = IRCamLibs.camStructures.pythonConfigToString
            #print toString[ndx](self.ircc.pythonConfig[key])
            self.pythonConfigEntries[ndx].set_text(toString[ndx](self.ircc.pythonConfig[key]))
            
    def sendValuesToRt(self, widget):
        self.ircc.host = self.hostEntry.get_text()
        #print "New IP is: ", self.ircc.host
        self.ircc.port = int(self.portEntry.get_text())
        #print "New port is: ", self.ircc.port
        for ndx, key in enumerate(self.ircc.pythonConfigKeys):
            fromString = IRCamLibs.camStructures.pythonConfigFromString
            self.ircc.pythonConfig[key] = fromString[ndx](self.pythonConfigEntries[ndx].get_text())
            #print "New %s is: "%(key), self.ircc.pythonConfig[key]
        self.ircc.sendPythonConfigStruct()


    

def main(ircc = None):
    det = pythonConfigParameters(ircc = None)
    gtk.main()

if __name__ == '__main__':
    main()

    
